<%@ Control Language="C#" Inherits="YourCompany.Modules.MfsWebcam.ViewMfsWebcam" AutoEventWireup="true" CodeBehind="ViewMfsWebcam.ascx.cs" %>

<script type="text/javascript">
    $(document).ready(function () {
        var pos = 0;
        var ctx = null;
        var cam = null;
        var image = null;
        var filter_on = false;
        var filter_id = 0;
        var timer = null;
        function changeFilter() {
            if (filter_on) {
                filter_id = (filter_id + 1) & 7;
            }
        }
        function toggleFilter(obj) {
            if (filter_on = !filter_on) {
                obj.parentNode.style.borderColor = "#c00";
            } else {
                obj.parentNode.style.borderColor = "#333";
            }
        }
        jQuery("#camera").webcam({
            width: 320,
            height: 240,
            mode: "callback",
            swffile: $('#<%= hfSwfPath.ClientID %>').val(),
            onTick: function (remain) {
                if (0 == remain) {
                    jQuery("#status").text("Cheese!");
                } else {
                    jQuery("#status").text(remain + " seconds remaining...");
                }
            },
            onSave: function (data) {
                var col = data.split(";");
                var img = image;
                if (false == filter_on) {
                    for (var i = 0; i < 320; i++) {
                        var tmp = parseInt(col[i]);
                        img.data[pos + 0] = (tmp >> 16) & 0xff;
                        img.data[pos + 1] = (tmp >> 8) & 0xff;
                        img.data[pos + 2] = tmp & 0xff;
                        img.data[pos + 3] = 0xff;
                        pos += 4;
                    }
                } else {
                    var id = filter_id;
                    var r, g, b;
                    var r1 = Math.floor(Math.random() * 255);
                    var r2 = Math.floor(Math.random() * 255);
                    var r3 = Math.floor(Math.random() * 255);
                    for (var i = 0; i < 320; i++) {
                        var tmp = parseInt(col[i]);
                        /* Copied some xcolor methods here to be faster than calling all methods inside of xcolor and to not serve complete library with every req */
                        if (id == 0) {
                            r = (tmp >> 16) & 0xff;
                            g = 0xff;
                            b = 0xff;
                        } else if (id == 1) {
                            r = 0xff;
                            g = (tmp >> 8) & 0xff;
                            b = 0xff;
                        } else if (id == 2) {
                            r = 0xff;
                            g = 0xff;
                            b = tmp & 0xff;
                        } else if (id == 3) {
                            r = 0xff ^ ((tmp >> 16) & 0xff);
                            g = 0xff ^ ((tmp >> 8) & 0xff);
                            b = 0xff ^ (tmp & 0xff);
                        } else if (id == 4) {
                            r = (tmp >> 16) & 0xff;
                            g = (tmp >> 8) & 0xff;
                            b = tmp & 0xff;
                            var v = Math.min(Math.floor(.35 + 13 * (r + g + b) / 60), 255);
                            r = v;
                            g = v;
                            b = v;
                        } else if (id == 5) {
                            r = (tmp >> 16) & 0xff;
                            g = (tmp >> 8) & 0xff;
                            b = tmp & 0xff;
                            if ((r += 32) < 0) r = 0;
                            if ((g += 32) < 0) g = 0;
                            if ((b += 32) < 0) b = 0;
                        } else if (id == 6) {
                            r = (tmp >> 16) & 0xff;
                            g = (tmp >> 8) & 0xff;
                            b = tmp & 0xff;
                            if ((r -= 32) < 0) r = 0;
                            if ((g -= 32) < 0) g = 0;
                            if ((b -= 32) < 0) b = 0;
                        } else if (id == 7) {
                            r = (tmp >> 16) & 0xff;
                            g = (tmp >> 8) & 0xff;
                            b = tmp & 0xff;
                            r = Math.floor(r / 255 * r1);
                            g = Math.floor(g / 255 * r2);
                            b = Math.floor(b / 255 * r3);
                        }
                        img.data[pos + 0] = r;
                        img.data[pos + 1] = g;
                        img.data[pos + 2] = b;
                        img.data[pos + 3] = 0xff;
                        pos += 4;
                    }
                }
                if (pos >= 0x4B000) {
                    ctx.putImageData(img, 0, 0);
                    pos = 0;
                }
            },
            onCapture: function () {
                webcam.save();
                jQuery("#flash").css("display", "block");
                jQuery("#flash").fadeOut(100, function () {
                    jQuery("#flash").css("opacity", 1);
                });

                if (timer != null) {
                    changeFilter();
                    clearTimeout(timer);
                }

            },
            debug: function (type, string) {
                //jQuery("#status").html(type + ": " + string);
            },
            onLoad: function () {
                var cams = webcam.getCameraList();
//                for (var i in cams) {
//                    jQuery("#cams").append("<li>" + cams[i] + "</li>");
//                }
            }
        });
        $('#btncapture').click(function () {
            webcam.capture();
            changeFilter();
            setVisibility();
        });
        $('#btnTimerSet').click(function () {
            timer = setTimeout("webcam.capture(); setVisibility();", 3000);
        });
        $('#<%= btnSave.ClientID %>').click(function () {
            var img = document.getElementById("canvas").toDataURL("image/png");
            img = img.replace('data:image/png;base64,', '');
            $('#<%= hfImageData.ClientID %>').val(img);
        });
        window.addEventListener("load", function () {
            jQuery("body").append("<div id=\"flash\"></div>");
            var canvas = document.getElementById("canvas");
            if (canvas.getContext) {
                ctx = document.getElementById("canvas").getContext("2d");
                var img = new Image();
                img.src = "DesktopModules/MfsWebcam/Tulips.jpg";
                img.onload = function () {
                }
                image = ctx.getImageData(0, 0, 320, 240);
            }
            var pageSize = getPageSize();
            $('#divCanvas').css("visibility", "visible");
            if ($('#divCamera').css("display") == "block")
                $('#divCanvas').css("display", "none");
        }, false);
        window.addEventListener("resize", function () {
            var pageSize = getPageSize();
            jQuery("#flash").css({ height: pageSize[1] + "px" });
        }, false);
        function getPageSize() {
            var xScroll, yScroll;
            if (window.innerHeight && window.scrollMaxY) {
                xScroll = window.innerWidth + window.scrollMaxX;
                yScroll = window.innerHeight + window.scrollMaxY;
            } else if (document.body.scrollHeight > document.body.offsetHeight) { // all but Explorer Mac
                xScroll = document.body.scrollWidth;
                yScroll = document.body.scrollHeight;
            } else { // Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
                xScroll = document.body.offsetWidth;
                yScroll = document.body.offsetHeight;
            }
            var windowWidth, windowHeight;
            if (self.innerHeight) { // all except Explorer
                if (document.documentElement.clientWidth) {
                    windowWidth = document.documentElement.clientWidth;
                } else {
                    windowWidth = self.innerWidth;
                }
                windowHeight = self.innerHeight;
            } else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
                windowWidth = document.documentElement.clientWidth;
                windowHeight = document.documentElement.clientHeight;
            } else if (document.body) { // other Explorers
                windowWidth = document.body.clientWidth;
                windowHeight = document.body.clientHeight;
            }
            // for small pages with total height less then height of the viewport
            if (yScroll < windowHeight) {
                pageHeight = windowHeight;
            } else {
                pageHeight = yScroll;
            }
            // for small pages with total width less then width of the viewport
            if (xScroll < windowWidth) {
                pageWidth = xScroll;
            } else {
                pageWidth = windowWidth;
            }
            return [pageWidth, pageHeight];
        }

        jQuery(function ($) {
            $('#canvas').Jcrop({
                onSelect: showCoords
            });
        });

        function showCoords(c) {

            document.getElementById('<%=x1.ClientID %>').value = c.x;
            document.getElementById('<%=y1.ClientID %>').value = c.y;
            document.getElementById('<%=x2.ClientID %>').value = c.x2;
            document.getElementById('<%=y2.ClientID %>').value = c.y2;
            document.getElementById('<%=w.ClientID %>').value = c.w;
            document.getElementById('<%=h.ClientID %>').value = c.h;
        }
    });

    function setVisibility() {
        if ($('#divCamera').css("display") == "block") {
            $('#divCamera').css("display", "none");
            $('#divCanvas').css("display", "block");
            $('#hlVisibility').html("Switch to Webcam");
        }
        else {
            $('#divCamera').css("display", "block");
            $('#divCanvas').css("display", "none");
            $('#hlVisibility').html("Switch to Image");
        }
    }

    function CheckForImageFile(file) {
        var fileName = file.value;
        var IsValidFile = false;

        //Checking for file browsed or not 
        if (trim(fileName, '') == '') {
            IsValidFile = true;
        }

        //Setting the extension array for diff. type of video files 
        var extArray = new Array(".jpg", ".jpeg", ".png", ".bmp");

        //getting the file name
        while (fileName.indexOf("\\") != -1)
            fileName = fileName.slice(fileName.indexOf("\\") + 1);

        //Getting the file extension                     
        var ext = fileName.slice(fileName.indexOf(".")).toLowerCase();

        //matching extension with our given extensions.
        for (var i = 0; i < extArray.length; i++) {
            if (extArray[i] == ext) {
                IsValidFile = true;
            }
        }

        if (IsValidFile) {
            document.getElementById('<%= btnShowImage.ClientID %>').click();
        } else {
            alert("Please only upload files that end in types:  " + (extArray.join("  ")));
            file.value = "";
            file.focus();
            return false;
        }
    }

    function trim(str, chars) {
        return ltrim(rtrim(str, chars), chars);
    }

    function ltrim(str, chars) {
        chars = chars || "\\s";
        return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
    }

    function rtrim(str, chars) {
        chars = chars || "\\s";
        return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
    }

    function setImageData() {
        $('#divCamera').css("display", "block");
        var imageData = $('#<%= hfImageData.ClientID %>').val();
        var canvas = document.getElementById("canvas");
        if (canvas.getContext) {
            ctx = document.getElementById("canvas").getContext("2d");
            var image = new Image();
            image.src = imageData.replace('', 'data:image/png;base64,');
            image.onload = function () {
                ctx.drawImage(image, 0, 0, 320, 240);
            }
        }       
        setVisibility();
    }
</script>

<div style="height:20px"><a id="hlVisibility" href="javascript:setVisibility();void(0);">Switch to Image</a></div>
<div id="divCamera" style="width:320px; height:300px; display:block">
    <div style=" width:320px; height:240px; border:5px solid #999999">
        <div id="camera"></div> 
    </div> 
    <p id="status"></p>      
    <ul id="cams"></ul>
    <input id="btncapture" type="button" value="Capture" />
    <input id="btnTimerSet" type="button" value="Take picture after 3 secs" />
</div>

<div id="divCanvas" style="width:320px; height:300px; visibility:hidden">
    <div style=" width:320px; height:240px; border:5px solid #999999">
        <canvas id="canvas" height="240" width="320"></canvas>  
    </div> 
    <div style="height:12px"></div>        
    <asp:FileUpload ID="ImgFileUpload" runat="server" onchange="CheckForImageFile(this);" />
    <asp:Button ID="btnSave" runat="server" Text="Save" OnClick="btnSaveImage_Click" />
    <asp:Button ID="btnShowImage" runat="server" Text="Save" OnClick="btnShowImage_Click" style="display:none" /> 
</div>

<asp:HiddenField ID="hfImageData" runat="server" />
<asp:HiddenField ID="x1" runat="server" />
<asp:HiddenField ID="y1" runat="server" />
<asp:HiddenField ID="x2" runat="server" />
<asp:HiddenField ID="y2" runat="server" />
<asp:HiddenField ID="w" runat="server" />
<asp:HiddenField ID="h" runat="server" />
<asp:HiddenField ID="hfSwfPath" runat="server" />